/****************************************/
/* Cool Herders                         */
/* A demented muse by Brendan Wiese     */
/* http://starbow.org                   */
/* Programmed by Mike Brent             */
/* http://tursi.yiffco.com              */
/* cool.h                               */
/****************************************/

extern int    fMusic, fSound;
extern uint32 txr_title, txr_sprites;
extern int PLAYFIELDXOFF;
extern int PLAYFIELDYOFF;	
extern int SHEEPSPEED;

typedef uint32 FILE;

#define MAX_SHEEP 30
#define HISTORY 120		// max sheep * 4 (4 is the speed)

// This structure is used for herders and sheep alike
typedef struct _herder{
	SPRITE spr;			// Sprite
	int32 destx, desty; // Destination - used for computer play
	int32 oldx[HISTORY+1];
	int32 oldy[HISTORY+1];	// Trails, and used by the computer to detect being stuck
	int32 oldidx;			// position in the trail
	uint32 address;		// Controller Address, 0 for none
	int32 type;			// Controller Type, 0 for computer, -1 for none
	uint32 vmu;			// VMU address, or 0 if none
	uint32 score;		// Score
	uint32 stuntime;	// if Stunned, for how much longer?
	uint32 animframe;	// animation frame counter
	uint32 maxframes;	// number of animation frames
	uint32 sheep;		// How many sheep
	uint32 range;		// range on the electric staff - for sheep, invincibility countdown
	uint32 maxrange;	// used to charge up the staff
	uint32 trap;		// what trap (disease) does this player have
	uint32 speed;		// how fast do they move?
	uint32 charge;		// charge level (10 units = 1 range)
	uint32 pen;			// how many sheep are in the pen
	uint32 penhp;		// how many hp are on the pen
} HerdStruct, *pHerdStruct;

int main(int argc, char *argv[]);
void AddPicture(uint32 txr_addr, float z);
void registerDummy(int typeTA);
void DoLogos(void);
int Game(void);
void ReScanVMUs(void);
void updateoldpos(pHerdStruct);
int doMenu(void);

extern abi_thread_t *thread;
extern abi_maple_t	*maple;
extern abi_ta_t		*ta;	 
extern abi_video_t	*video;
extern abi_fs_t		*fs;
extern abi_spu_t	*spu;
extern abi_sndsrv_t	*sound;

#define min(a,b) (a<b?a:b)
